#!/bin/sh

#Copyright (C) 2007-2008 PeerTV Inc.
#All rights reserved.

. /etc/profile
if [ -z "$HDD_DEVICE" ]; then
	HDD_DEVICE=/dev/hda
fi

# Turn on debug mode
set -x

echo 
echo "New partition scheme script"
echo

upgrade_eng_path=/bin/upgrade
export PATH=$PATH:$upgrade_eng_path
alt_browser=0

if [ "$SIGMA22" = "YES" ]; then
        insmod llad.o
        insmod em8xxx.o
        insmod mambolfb.o
fi

# userfs integrity test
$upgrade_eng_path/chkufs.sh
if [ $? = 0 ]; then
	# mounting SYSTEM_PATH
	mtd_block_num=`cat /proc/upgrade/userfs_num`
	mount -t cramfs -r /dev/mtdblock$mtd_block_num $SYSTEM_PATH

	# must be read before mounting cfgfs !
	if [ "$SIGMA34" = "YES" ]; then
                rootfs_mrua_version=`cat /etc/mipsutils_version`
        	userfs_mrua_version=`cat /system/mipsutils_version`
	else
        	rootfs_mrua_version=`cat /etc/armutils_version`
        	userfs_mrua_version=`cat /system/armutils_version`
	fi

	# Verifying MRUA version rootfs/userfs competability 
	if [ "$rootfs_mrua_version" != "$userfs_mrua_version" ]; then
		echo "MRUA ver. of rootfs&userfs is not competible"
		echo "MRUA ver. of rootfs&userfs is not competible" > /tmp/usbd_osd

		alt_browser=1
	fi
else
	alt_browser=1
	echo "USERFS is damaged !"
fi

if [ $alt_browser -eq 0 ]; then
	# Loading browser
	makesettings.upg
else
	# Loading alt. browser
	$upgrade_eng_path/ascii_browser 0 -X 50 -Y 50 -S 2 -F 255,255,255,255 -B 0,0,255,255 -T 1 $upgrade_eng_path/font.psf " " &
fi

# calculating overall stages number for different scenarios
if [ "$SIGMA22" = "YES" ]; then
        tmp_hd_format_stages=4
else
        tmp_hd_format_stages=4
fi

echo 0 > /tmp/usbd_pb_total
echo 0 > /tmp/usbd_pb_cur
echo 0 > /tmp/usbd_status_num
echo $tmp_hd_format_stages > /tmp/usbd_status_num_max

modprobe ext3
appsbin_path=$USB_PATH/utils
echo "DISK_FORMAT" > /tmp/usbd_action
$appsbin_path/sfdisk --force -uM $HDD_DEVICE < $appsbin_path/std_partitions
$appsbin_path/mke2fs -j "$HDD_DEVICE"1 
if [ "`cat /tmp/usbd_action`" = "DISK_FORMAT_ERROR" ]; then
	echo "Remove dok and wait for reboot"
	while [ 0 = 0 ]; do
		grep usb /proc/hardware > /dev/null 2>&1
		if [ $? -ne 0 ]; then
			echo "no usb attached"
			/sbin/reboot
			exit 255
		fi
		sleep 2
	done
        exit 0
fi

$appsbin_path/mke2fs -j "$HDD_DEVICE"2 
if [ "`cat /tmp/usbd_action`" = "DISK_FORMAT_ERROR" ]; then
	echo "Remove dok and wait for reboot"
	while [ 0 = 0 ]; do
		grep usb /proc/hardware > /dev/null 2>&1
		if [ $? -ne 0 ]; then
			echo "no usb attached"
			/sbin/reboot
			exit 255
		fi
		sleep 2
	done
        exit 0
fi

$appsbin_path/mke2fs -j -b 4096 "$HDD_DEVICE"3 
if [ "`cat /tmp/usbd_action`" = "DISK_FORMAT_ERROR" ]; then
	echo "Remove dok and wait for reboot"
	while [ 0 = 0 ]; do
		grep usb /proc/hardware > /dev/null 2>&1
		if [ $? -ne 0 ]; then
			echo "no usb attached"
			/sbin/reboot
			exit 255
		fi
		sleep 2
	done
        exit 0
fi

echo "DONE! Please remove the disk on key and reboot the system"

# Requesting reboot
echo "Remove dok and wait for reboot" > /tmp/usbd_osd
echo 100 > /tmp/usbd_pb_total
echo 100 > /tmp/usbd_pb_cur
sleep 1
echo "DONEUSB" > /tmp/usbd_action

# Waiting for reboot
echo "Remove dok and wait for reboot"
while [ 0 = 0 ]; do
	grep usb /proc/hardware > /dev/null 2>&1
	if [ $? -ne 0 ]; then
		echo "no usb attached"
		/sbin/reboot
                exit 255
	fi
	sleep 2
done
exit 0
